diff --git a/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java b/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
index ca52ae79e..8485dd9dc 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/achievements/ScreenAchievements.java
@@ -9,7 +9,6 @@ import net.minecraft.client.gui.achievements.data.AchievementPageRegistry;
 import net.minecraft.client.gui.achievements.data.AchievementPages;
 import net.minecraft.client.gui.options.OptionsButtonElement;
 import net.minecraft.client.render.Lighting;
-import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.Scissor;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.renderer.BlendFactor;
@@ -25,6 +24,7 @@ import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.achievement.Achievement;
 import net.minecraft.core.achievement.stat.StatsCounter;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.sound.SoundCategory;
@@ -884,12 +884,12 @@ public class ScreenAchievements extends Screen
             GLRenderer.pushFrame();
             GLRenderer.globalSetLightEnabled(true);
             GLRenderer.enableState(State.CULL_FACE);
-            Item achievementItem = Item.itemsList[ach.iconItemId];
+            ItemStack achievementItem = ach.iconStack;
 
             GLRenderer.modelM4f().translate((float) (achViewX + 3 * zoom), (float) (achViewY + 3 * zoom), 0);
             GLRenderer.modelM4f().scale((float) zoom, (float) zoom, 1);
 //            ItemModelDispatcher.getInstance().getDispatch(achievementItem).renderItemIntoGui(GLRenderer.getTessellator(), mc.font, mc.textureManager, achievementItem.getDefaultStack(), 0, 0, 1.0f);
-            ItemModelDispatcher.getInstance().getDispatch(achievementItem).renderGui(GLRenderer.getTessellator(), null, achievementItem.getDefaultStack(), 0, 0, LightIndexHelper.lightIndex2i(15, 15), 1f);
+            ItemModelDispatcher.getInstance().getDispatch(achievementItem).renderGui(GLRenderer.getTessellator(), null, achievementItem, 0, 0, LightIndexHelper.lightIndex2i(15, 15), 1f);
 
             GLRenderer.globalSetLightEnabled(false);
             GLRenderer.popFrame();
@@ -926,7 +926,7 @@ public class ScreenAchievements extends Screen
             boxRender = this.tooltip.drawBackground(mouseX, mouseY, TOOLTIP_OFF_X, TOOLTIP_OFF_Y, boxWidth + 3, boxHeight + 3 + 12);
             this.fontRenderer.renderWidthConstrained(msg, boxRender[0] + padding, boxRender[1] + 12 + padding, boxWidth).setColor(0xff705050).call();
         }
-        int color = this.statsCounter.canUnlock(achievement) ? achievement.getType().colorName : achievement.getType().colorNameLocked;
+        int color = this.statsCounter.canUnlock(achievement) ? achievement.getType().colorName() : achievement.getType().colorNameLocked();
         drawStringShadow(this.fontRenderer, name, boxRender[0] + padding, boxRender[1] + padding, color);
     }
     public boolean drawSidebar(){
diff --git a/game/client/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageNether.java b/game/client/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageNether.java
index 264f94275..3353e308d 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageNether.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageNether.java
@@ -106,7 +106,7 @@ public class AchievementPageNether extends AchievementPage {
 
     @Override
     public IconCoordinate getAchievementIcon(Achievement achievement) {
-        return TextureRegistry.getTexture(achievement.getType().texture);
+        return TextureRegistry.getTexture(achievement.getType().texture());
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageOverworld.java b/game/client/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageOverworld.java
index 8ab77a790..7db6d7a51 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageOverworld.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/achievements/pages/AchievementPageOverworld.java
@@ -125,7 +125,7 @@ public class AchievementPageOverworld extends AchievementPage {
 
                 for (int rY = y; rY - orgY >= 0; rY--) {
                     if (rY == y) {
-                        layer.put(TextureRegistry.getTexture("minecraft:block/grass/side"), _x - orgX, rY - orgY);
+                        layer.put(TextureRegistry.getTexture("minecraft:block/grass/side_colored_achievement"), _x - orgX, rY - orgY); // TODO, need to evaluate how to properly implement colorations into the achievement background
                     } else {
                         layer.put(null, _x - orgX, rY - orgY);
                     }
@@ -309,7 +309,7 @@ public class AchievementPageOverworld extends AchievementPage {
 
     @Override
     public IconCoordinate getAchievementIcon(Achievement achievement) {
-        return TextureRegistry.getTexture(achievement.getType().texture);
+        return TextureRegistry.getTexture(achievement.getType().texture());
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenActivator.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenActivator.java
index 1aa3ea217..57075ada5 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenActivator.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenActivator.java
@@ -91,7 +91,7 @@ public class ScreenActivator extends ScreenContainerAbstract {
         @Override
         protected void mousePressed(int x, int y, @Nullable Slot slot, int button) {
             if (button != 1 || super.isDragging() ||
-                super.getGrabbedItem() != null || slot == null || slot.getItemStack() != null
+                super.getGrabbedItem() != null || (slot != null && slot.getItemStack() != null)
             ) {
                 super.mousePressed(x, y, slot, button);
                 return;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/AvailableTexturePackListComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/AvailableTexturePackListComponent.java
index 9265f6782..3a6bc2003 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/AvailableTexturePackListComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/AvailableTexturePackListComponent.java
@@ -175,19 +175,21 @@ public class AvailableTexturePackListComponent
 
             int rgbVersion = 0x808080;
             int format = this.texturePack.manifest.getFormat();
+            int minFormat = this.texturePack.manifest.getMinFormat();
+            int maxFormat = this.texturePack.manifest.getMaxFormat();
 
-			if(format == Global.ASSET_PACK_FORMAT) {
-				// Correct version
-                mc.font.render(this.texturePack.manifest.getName(), x + this.height + 2, y + 1).call();
+            if(format == -1) {
+                // Manifest error
+                mc.font.render(TextFormatting.RED + this.texturePack.manifest.getName(), x + this.height + 2, y + 1).call();
                 mc.font.render(this.texturePack.manifest.getDescriptionLine1(), x + this.height + 2, y + 12).setColor(0x808080).call();
                 mc.font.render(this.texturePack.manifest.getDescriptionLine2(), x + this.height + 2, y + 22).setColor(0x808080).call();
-			}else if(format == -1) {
-				// Manifest error
-                mc.font.render(TextFormatting.RED + this.texturePack.manifest.getName(), x + this.height + 2, y + 1).call();
+                rgbVersion = Colors.allChatColors[TextFormatting.RED.id].getARGB();
+            } else if(minFormat <= Global.ASSET_PACK_FORMAT && Global.ASSET_PACK_FORMAT <= maxFormat) {
+				// Correct version
+                mc.font.render(this.texturePack.manifest.getName(), x + this.height + 2, y + 1).call();
                 mc.font.render(this.texturePack.manifest.getDescriptionLine1(), x + this.height + 2, y + 12).setColor(0x808080).call();
                 mc.font.render(this.texturePack.manifest.getDescriptionLine2(), x + this.height + 2, y + 22).setColor(0x808080).call();
-				rgbVersion = Colors.allChatColors[TextFormatting.RED.id].getARGB();
-			}else {
+			} else {
 				// Wrong texture pack version
 				I18n i18n = I18n.getInstance();
                 mc.font.render(TextFormatting.RED + this.texturePack.manifest.getName(), x + this.height + 2, y + 1).call();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/SelectedTexturePackListComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/SelectedTexturePackListComponent.java
index 0a8b892cc..d86dd3efe 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/SelectedTexturePackListComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/SelectedTexturePackListComponent.java
@@ -283,18 +283,20 @@ public class SelectedTexturePackListComponent implements OptionsComponent {
 
             int rgbVersion = 0x808080;
             int format = this.texturePack.manifest.getFormat();
+            int minFormat = this.texturePack.manifest.getMinFormat();
+            int maxFormat = this.texturePack.manifest.getMaxFormat();
 
-            if (format == Global.ASSET_PACK_FORMAT) {
-                // Correct version
-                mc.font.render(this.texturePack.manifest.getName(), x + this.xPos + this.height + 2, y + this.yPos + 1).call();
-                mc.font.render(this.texturePack.manifest.getDescriptionLine1(), x + this.xPos + this.height + 2, y + this.yPos + 12).setColor(0x808080).call();
-                mc.font.render(this.texturePack.manifest.getDescriptionLine2(), x + this.xPos + this.height + 2, y + this.yPos + 22).setColor(0x808080).call();
-            } else if (format == -1) {
+            if (format == -1) {
                 // Manifest error
                 mc.font.render(TextFormatting.RED + this.texturePack.manifest.getName(), x + this.xPos + this.height + 2, y + this.yPos + 1).call();
                 mc.font.render(this.texturePack.manifest.getDescriptionLine1(), x + this.xPos + this.height + 2, y + this.yPos + 12).setColor(0x808080).call();
                 mc.font.render(this.texturePack.manifest.getDescriptionLine2(), x + this.xPos + this.height + 2, y + this.yPos + 22).setColor(0x808080).call();
                 rgbVersion = Colors.allChatColors[TextFormatting.RED.id].getARGB();
+            } else if(minFormat <= Global.ASSET_PACK_FORMAT && Global.ASSET_PACK_FORMAT <= maxFormat) {
+                // Correct version
+                mc.font.render(this.texturePack.manifest.getName(), x + this.xPos + this.height + 2, y + this.yPos + 1).call();
+                mc.font.render(this.texturePack.manifest.getDescriptionLine1(), x + this.xPos + this.height + 2, y + this.yPos + 12).setColor(0x808080).call();
+                mc.font.render(this.texturePack.manifest.getDescriptionLine2(), x + this.xPos + this.height + 2, y + this.yPos + 22).setColor(0x808080).call();
             } else {
                 // Wrong texture pack version
                 I18n i18n = I18n.getInstance();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/toasts/AchievementToast.java b/game/client/src/main/java/net/minecraft/client/gui/toasts/AchievementToast.java
index 3b4610a6d..d7171c5a1 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/toasts/AchievementToast.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/toasts/AchievementToast.java
@@ -92,7 +92,7 @@ public class AchievementToast implements IToastable {
 
     @Override
     public @Nullable ItemStack getIcon(long runtime) {
-        return Item.getItem(achievement.iconItemId).getDefaultStack();
+        return achievement.iconStack;
     }
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index dd3b77653..4093a4acd 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -74,7 +74,7 @@ import java.util.Random;
 
 import static java.awt.Color.HSBtoRGB;
 
-public class RenderGlobal
+public final class RenderGlobal
     implements LevelListener {
     public static IconCoordinate[] breakingAnimation = new IconCoordinate[10];
 
@@ -937,27 +937,36 @@ public class RenderGlobal
         GLRenderer.disableState(State.CULL_FACE);
         float cameraY = (float) this.mc.activeCamera.getY(partialTick);
         TessellatorShader tessellator = GLRenderer.getTessellator();
-        float cloudWidth = 12F;
-        float cloudThickness = 4F;
-        double dx = (this.mc.activeCamera.getX(partialTick) + (double) ((this.lastCloudOffsetX + (this.cloudOffsetX - this.lastCloudOffsetX) * partialTick) * 0.03F)) / (double) cloudWidth;
-        double dz = (this.mc.activeCamera.getZ(partialTick) + (double) ((this.lastCloudOffsetZ + (this.cloudOffsetZ - this.lastCloudOffsetZ) * partialTick) * 0.03F)) / (double) cloudWidth + 0.33D;
-        float dy = (worldTypeFX.getCloudHeight(world) - cameraY) + 0.33F + getCloudHeightModifier();
-        int i = MathHelper.floor(dx / 2048D);
-        int j = MathHelper.floor(dz / 2048D);
-        dx -= i * 2048;
-        dz -= j * 2048;
+        float ss = 12F;
+        float h = 4F;
+        double xo = (this.mc.activeCamera.getX(partialTick) + (double) ((this.lastCloudOffsetX + (this.cloudOffsetX - this.lastCloudOffsetX) * partialTick) * 0.03F)) / (double) ss;
+        double zo = (this.mc.activeCamera.getZ(partialTick) + (double) ((this.lastCloudOffsetZ + (this.cloudOffsetZ - this.lastCloudOffsetZ) * partialTick) * 0.03F)) / (double) ss + 0.33D;
+        float yy = (worldTypeFX.getCloudHeight(this.world) - cameraY) + 0.33F + getCloudHeightModifier();
+        int xOffs = MathHelper.floor(xo / 2048D);
+        int zOffs = MathHelper.floor(zo / 2048D);
+        xo -= xOffs * 2048;
+        zo -= zOffs * 2048;
+
+        boolean noBFCMode = ( (yy > -h - 1) && (yy <= h + 1) );
+        if( noBFCMode ) {
+            GLRenderer.disableState(State.CULL_FACE);
+        }
+        else {
+            GLRenderer.enableState(State.CULL_FACE);
+        }
+
         this.textureManager.loadTexture("/assets/minecraft/textures/environment/clouds.png").bind();
         GLRenderer.enableState(State.BLEND);
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
-        float f13 = 1F / 256F;
-        float f9 = (float) MathHelper.floor(dx) * f13;
-        float f11 = (float) MathHelper.floor(dz) * f13;
-        float f14 = (float) (dx - (double) MathHelper.floor(dx));
-        float f15 = (float) (dz - (double) MathHelper.floor(dz));
-        final int cloudWidthScale = 8;
+        float scale = 1F / 256F;
+        float uo = (float) MathHelper.floor(xo) * scale;
+        float vo = (float) MathHelper.floor(zo) * scale;
+        float xoffs2 = (float) (xo - (double) MathHelper.floor(xo));
+        float zoffs2 = (float) (zo - (double) MathHelper.floor(zo));
+        final int D = 8;
         final byte radius = (byte) Math.max(1, 3 * GameSettings.CLOUD_RENDER_DISTANCE.value);
-        float f16 = 1F / 1024F;
-        GLRenderer.modelM4f().scale(cloudWidth, 1.0F, cloudWidth);
+        float e = 1F / 1024F;
+        GLRenderer.modelM4f().scale(ss, 1.0F, ss);
 
         float red = rDim + (rSun - rDim) * aSun;
         float green = gDim + (gSun - gDim) * aSun;
@@ -965,75 +974,80 @@ public class RenderGlobal
 
         tessellator.startDrawingQuads();
         {
-            float width = (radius * 2 + 2) * cloudWidthScale;
-            float minX = (-radius - 1) * cloudWidthScale;
-            float minZ = (-radius - 1) * cloudWidthScale;
-            float cloudX = minX - f14;
-            float cloudZ = minZ - f15;
-            if (dy > -cloudThickness - 1.0F) {
+            float width = (radius * 2 + 2) * D;
+            float xx = (-radius - 1) * D;
+            float zz = (-radius - 1) * D;
+            float xp = xx - xoffs2;
+            float zp = zz - zoffs2;
+            if (yy > -h - 1.0F) {
                 tessellator.setColor4f(red * 0.7F, green * 0.7F, blue * 0.7F, 0.8F);
                 tessellator.setNormal(0.0F, -1F, 0.0F);
-                tessellator.addVertexWithUV(cloudX + 0.0F, dy + 0.0F, cloudZ + width, (minX + 0.0F) * f13 + f9, (minZ + width) * f13 + f11);
-                tessellator.addVertexWithUV(cloudX + width, dy + 0.0F, cloudZ + width, (minX + width) * f13 + f9, (minZ + width) * f13 + f11);
-                tessellator.addVertexWithUV(cloudX + width, dy + 0.0F, cloudZ + 0.0F, (minX + width) * f13 + f9, (minZ + 0.0F) * f13 + f11);
-                tessellator.addVertexWithUV(cloudX + 0.0F, dy + 0.0F, cloudZ + 0.0F, (minX + 0.0F) * f13 + f9, (minZ + 0.0F) * f13 + f11);
+                tessellator.addVertexWithUV(xp + 0.0F, yy + 0.0F, zp + 0.0F, (xx + 0.0F) * scale + uo, (zz + 0.0F) * scale + vo);
+                tessellator.addVertexWithUV(xp + width, yy + 0.0F, zp + 0.0F, (xx + width) * scale + uo, (zz + 0.0F) * scale + vo);
+                tessellator.addVertexWithUV(xp + width, yy + 0.0F, zp + width, (xx + width) * scale + uo, (zz + width) * scale + vo);
+                tessellator.addVertexWithUV(xp + 0.0F, yy + 0.0F, zp + width, (xx + 0.0F) * scale + uo, (zz + width) * scale + vo);
             }
-            if (dy <= cloudThickness + 1.0F) {
+            if (yy <= h + 1.0F) {
                 tessellator.setColor4f(red, green, blue, 0.8F);
                 tessellator.setNormal(0.0F, 1.0F, 0.0F);
-                tessellator.addVertexWithUV(cloudX + 0.0F, (dy + cloudThickness) - f16, cloudZ + width, (minX + 0.0F) * f13 + f9, (minZ + width) * f13 + f11);
-                tessellator.addVertexWithUV(cloudX + width, (dy + cloudThickness) - f16, cloudZ + width, (minX + width) * f13 + f9, (minZ + width) * f13 + f11);
-                tessellator.addVertexWithUV(cloudX + width, (dy + cloudThickness) - f16, cloudZ + 0.0F, (minX + width) * f13 + f9, (minZ + 0.0F) * f13 + f11);
-                tessellator.addVertexWithUV(cloudX + 0.0F, (dy + cloudThickness) - f16, cloudZ + 0.0F, (minX + 0.0F) * f13 + f9, (minZ + 0.0F) * f13 + f11);
+                tessellator.addVertexWithUV(xp + 0.0F, (yy + h) - e, zp + 0.0F, (xx + 0.0F) * scale + uo, (zz + 0.0F) * scale + vo);
+                tessellator.addVertexWithUV(xp + 0.0F, (yy + h) - e, zp + width, (xx + 0.0F) * scale + uo, (zz + width) * scale + vo);
+                tessellator.addVertexWithUV(xp + width, (yy + h) - e, zp + width, (xx + width) * scale + uo, (zz + width) * scale + vo);
+                tessellator.addVertexWithUV(xp + width, (yy + h) - e, zp + 0.0F, (xx + width) * scale + uo, (zz + 0.0F) * scale + vo);
             }
         }
         for (int ix = -radius - 1; ix <= radius + 1; ix++) {
             for (int iz = -radius - 1; iz <= radius + 1; iz++) {
-
-                float f17 = ix * cloudWidthScale;
-                float f18 = iz * cloudWidthScale;
-                float cloudX = f17 - f14;
-                float cloudZ = f18 - f15;
+                float xx = ix * D;
+                float zz = iz * D;
+                float cloudX = xx - xoffs2;
+                float cloudZ = zz - zoffs2;
                 tessellator.setColor4f(red * 0.9F, green * 0.9F, blue * 0.9F, 0.8F);
                 if (ix > -1) {
                     tessellator.setNormal(-1F, 0.0F, 0.0F);
-                    for (int k1 = 0; k1 < cloudWidthScale; k1++) {
-                        tessellator.addVertexWithUV(cloudX + (float) k1 + 0.0F, dy + 0.0F, cloudZ + (float) cloudWidthScale, (f17 + (float) k1 + 0.5F) * f13 + f9, (f18 + (float) cloudWidthScale) * f13 + f11);
-                        tessellator.addVertexWithUV(cloudX + (float) k1 + 0.0F, dy + cloudThickness, cloudZ + (float) cloudWidthScale, (f17 + (float) k1 + 0.5F) * f13 + f9, (f18 + (float) cloudWidthScale) * f13 + f11);
-                        tessellator.addVertexWithUV(cloudX + (float) k1 + 0.0F, dy + cloudThickness, cloudZ + 0.0F, (f17 + (float) k1 + 0.5F) * f13 + f9, (f18 + 0.0F) * f13 + f11);
-                        tessellator.addVertexWithUV(cloudX + (float) k1 + 0.0F, dy + 0.0F, cloudZ + 0.0F, (f17 + (float) k1 + 0.5F) * f13 + f9, (f18 + 0.0F) * f13 + f11);
+                    for (int s = 0; s < D; s++) {
+                        final float u = (xx + s + 0.5F) * scale + uo;
+                        tessellator.addVertexWithUV(cloudX + s + 0.0F, yy + 0.0F, cloudZ + 0.0F, u, (zz + 0.0F) * scale + vo);
+                        tessellator.addVertexWithUV(cloudX + s + 0.0F, yy + 0.0F, cloudZ + D, u, (zz + D) * scale + vo);
+                        tessellator.addVertexWithUV(cloudX + s + 0.0F, yy + h, cloudZ + D, u, (zz + D) * scale + vo);
+                        tessellator.addVertexWithUV(cloudX + s + 0.0F, yy + h, cloudZ + 0.0F, u, (zz + 0.0F) * scale + vo);
                     }
+                }
 
-                } else {
+                if (ix <= 1) {
                     tessellator.setNormal(1.0F, 0.0F, 0.0F);
-                    for (int l1 = 0; l1 < cloudWidthScale; l1++) {
-                        tessellator.addVertexWithUV((cloudX + (float) l1 + 1.0F) - f16, dy + 0.0F, cloudZ + (float) cloudWidthScale, (f17 + (float) l1 + 0.5F) * f13 + f9, (f18 + (float) cloudWidthScale) * f13 + f11);
-                        tessellator.addVertexWithUV((cloudX + (float) l1 + 1.0F) - f16, dy + cloudThickness, cloudZ + (float) cloudWidthScale, (f17 + (float) l1 + 0.5F) * f13 + f9, (f18 + (float) cloudWidthScale) * f13 + f11);
-                        tessellator.addVertexWithUV((cloudX + (float) l1 + 1.0F) - f16, dy + cloudThickness, cloudZ + 0.0F, (f17 + (float) l1 + 0.5F) * f13 + f9, (f18 + 0.0F) * f13 + f11);
-                        tessellator.addVertexWithUV((cloudX + (float) l1 + 1.0F) - f16, dy + 0.0F, cloudZ + 0.0F, (f17 + (float) l1 + 0.5F) * f13 + f9, (f18 + 0.0F) * f13 + f11);
+                    for (int s = 0; s < D; s++) {
+                        final float u = (xx + s + 0.5F) * scale + uo;
+                        tessellator.addVertexWithUV((cloudX + s + 1.0F) - e, yy + 0.0F, cloudZ + 0.0F, u, (zz + 0.0F) * scale + vo);
+                        tessellator.addVertexWithUV((cloudX + s + 1.0F) - e, yy + h, cloudZ + 0.0F, u, (zz + 0.0F) * scale + vo);
+                        tessellator.addVertexWithUV((cloudX + s + 1.0F) - e, yy + h, cloudZ + D, u, (zz + D) * scale + vo);
+                        tessellator.addVertexWithUV((cloudX + s + 1.0F) - e, yy + 0.0F, cloudZ + D, u, (zz + D) * scale + vo);
                     }
-
                 }
+
                 tessellator.setColor4f(red * 0.8F, green * 0.8F, blue * 0.8F, 0.8F);
+                tessellator.setNormal(0.0F, 0.0F, -1F);
                 if (iz > -1) {
-                    tessellator.setNormal(0.0F, 0.0F, -1F);
-                    for (int i2 = 0; i2 < cloudWidthScale; i2++) {
-                        tessellator.addVertexWithUV(cloudX + 0.0F, dy + cloudThickness, cloudZ + (float) i2 + 0.0F, (f17 + 0.0F) * f13 + f9, (f18 + (float) i2 + 0.5F) * f13 + f11);
-                        tessellator.addVertexWithUV(cloudX + (float) cloudWidthScale, dy + cloudThickness, cloudZ + (float) i2 + 0.0F, (f17 + (float) cloudWidthScale) * f13 + f9, (f18 + (float) i2 + 0.5F) * f13 + f11);
-                        tessellator.addVertexWithUV(cloudX + (float) cloudWidthScale, dy + 0.0F, cloudZ + (float) i2 + 0.0F, (f17 + (float) cloudWidthScale) * f13 + f9, (f18 + (float) i2 + 0.5F) * f13 + f11);
-                        tessellator.addVertexWithUV(cloudX + 0.0F, dy + 0.0F, cloudZ + (float) i2 + 0.0F, (f17 + 0.0F) * f13 + f9, (f18 + (float) i2 + 0.5F) * f13 + f11);
+                    for (int s = 0; s < D; s++) {
+                        final float v = (zz + s + 0.5F) * scale + vo;
+                        tessellator.addVertexWithUV(cloudX + 0.0F, yy + 0.0F, cloudZ + s + 0.0F, (xx + 0.0F) * scale + uo, v);
+                        tessellator.addVertexWithUV(cloudX + 0.0F, yy + h, cloudZ + s + 0.0F, (xx + 0.0F) * scale + uo, v);
+                        tessellator.addVertexWithUV(cloudX + D, yy + h, cloudZ + s + 0.0F, (xx + D) * scale + uo, v);
+                        tessellator.addVertexWithUV(cloudX + D, yy + 0.0F, cloudZ + s + 0.0F, (xx + D) * scale + uo, v);
                     }
+                }
 
-                } else {
-                    tessellator.setNormal(0.0F, 0.0F, 1.0F);
-                    for (int j2 = 0; j2 < cloudWidthScale; j2++) {
-                        tessellator.addVertexWithUV(cloudX + 0.0F, dy + cloudThickness, (cloudZ + (float) j2 + 1.0F) - f16, (f17 + 0.0F) * f13 + f9, (f18 + (float) j2 + 0.5F) * f13 + f11);
-                        tessellator.addVertexWithUV(cloudX + (float) cloudWidthScale, dy + cloudThickness, (cloudZ + (float) j2 + 1.0F) - f16, (f17 + (float) cloudWidthScale) * f13 + f9, (f18 + (float) j2 + 0.5F) * f13 + f11);
-                        tessellator.addVertexWithUV(cloudX + (float) cloudWidthScale, dy + 0.0F, (cloudZ + (float) j2 + 1.0F) - f16, (f17 + (float) cloudWidthScale) * f13 + f9, (f18 + (float) j2 + 0.5F) * f13 + f11);
-                        tessellator.addVertexWithUV(cloudX + 0.0F, dy + 0.0F, (cloudZ + (float) j2 + 1.0F) - f16, (f17 + 0.0F) * f13 + f9, (f18 + (float) j2 + 0.5F) * f13 + f11);
+                tessellator.setNormal(0.0F, 0.0F, 1.0F);
+                if (iz <= 1) {
+                    for (int s = 0; s < D; s++) {
+                        final float v = (zz + s + 0.5F) * scale + vo;
+                        tessellator.addVertexWithUV(cloudX + 0.0, yy + 0.0, (cloudZ + s + 1.0) - e, (xx + 0.0) * scale + uo, v);
+                        tessellator.addVertexWithUV(cloudX + D, yy + 0.0, (cloudZ + s + 1.0) - e, (xx + D) * scale + uo, v);
+                        tessellator.addVertexWithUV(cloudX + D, yy + h, (cloudZ + s + 1.0) - e, (xx + D) * scale + uo, v);
+                        tessellator.addVertexWithUV(cloudX + 0., yy + h, (cloudZ + s + 1.0) - e, (xx + 0.0) * scale + uo, v);
                     }
-
                 }
+
             }
 
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index b65bbd6c7..0a10aed30 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -240,7 +240,7 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelGeneric<>(Blocks.GRAVEL, loadDataModel("minecraft:block/gravel")));
         addDispatch(new BlockModelGeneric<>(Blocks.BRIMSAND, loadDataModel("minecraft:block/brimsand")));
 
-        addDispatch(new BlockModelGeneric<>(Blocks.BEDROCK, loadDataModel("minecraft:block/bedrock")));
+        addDispatch(new BlockModelGenericCullBounderies<>(Blocks.BEDROCK, loadDataModel("minecraft:block/bedrock")));
         addDispatch(new BlockModelGenericFullyRotatable<>(Blocks.BONESHALE,
                 loadDataModel("minecraft:block/bone_shale")));
 
